SuperStrict

' holzchopf - deathclick
' BCC #85

Framework brl.glmax2d
Import brl.pngloader
Import brl.timer
Import brl.random
Import brl.linkedlist

' output setup
Const SCREEN_WIDTH:Int		= 1024
Const SCREEN_HEIGHT:Int		= 768
Const SCREEN_UNIT:Int		= SCREEN_WIDTH /16.0
Const SCREEN_VUNIT:Int		= SCREEN_HEIGHT /12.0
Const HERTZ:Int				= 60
' game states
Const STATE_MENU:Int				= 0
Const STATE_GAME:Int				= 1
Const STATE_ENTERNAME:Int			= 2
Const STATE_GAMEOVER:Int			= 3
Const STATE_END:Int					= 4
' intermediate states (fading)
Const STATEFADE_IN:Int				= 0
Const STATEFADE_IDLE:Int			= 1
Const STATEFADE_OUT:Int				= 2
Const STATEFADE_MAXVALUE:Float		= 1.0
Const STATEFADE_STEPVALUE:Float 	= STATEFADE_MAXVALUE / HERTZ
' interface settings
Const BUTTON_WIDTH:Int				= 6 * SCREEN_UNIT
Const BUTTON_HEIGHT:Int				= 1 * SCREEN_UNIT
' colors (overall)
Global COLOR_WHITE:Int[]			= [255,255,255]
Global COLOR_BACKGROUND:Int[]		= [154,147,147]
Global COLOR_HUD:Int[]				= [255,192,0]
Global COLOR_MENU_TEXT:Int[]		= [255,255,255]
Global COLOR_MENU_HIGHLIGHT:Int[]	= [255,192,0]
Global COLOR_NAME_INPUT:Int[]		= [0,212,255]
Global COLOR_BUTTON_FILL:Int[]		= [168,161,161]
Global COLOR_BUTTON_STROKE:Int[]	= [126,117,117]
Global COLOR_BUTTON_FILL_HL:Int[]	= [165,216,238]
Global COLOR_BUTTON_STROKE_HL:Int[]	= [33,133,177]
Global COLOR_BUTTON_TEXT:Int[]		= [255,192,0]
Global COLOR_HIGHSCORE_NEW:Int[]	= [255,192,0]
Global COLOR_COUNTDOWN:Int[]		= [0,212,255]
' game settings, monster
Const MONSTER_CNT:Int				= 7
Const MONSTER_POS_CNT:Int			= 5
Const LAYER_CNT:Int					= MONSTER_POS_CNT
Global MONSTER_POSITIONS:Float[][]	= [[04#,04#],[12#,04#],[06#,04.75#],[10#,05.5#],[08#,06.25#]]
Const MONSTER_HEALTH:Int			= 100
Const MONSTER_MOTION_VEL:Int		= 90
Const MONSTER_MOTION_AMP_X:Int		= 16
Const MONSTER_MOTION_AMP_Y:Int		= 4
Global MONSTER_HIT_BLINKTIME:Int	= 100
Global MONSTER_HIT_COLOR:Int[]		= [128,128,128]
Global MONSTER_SHADOW_Y:Int			= 224
' healthbar
Const HEALTHBAR_X:Int				= -225
Const HEALTHBAR_Y:Int				= -240
Const HEALTHBAR_WIDTH:Int			= 450
Const HEALTHBAR_HEIGHT:Int			= 20
Global HEALTHBAR_COLOR:Int[]		= [0,255,0]
' helpers
Const HELPER_CNT:Int				= 2	
Const HELPER_LEFT:Int				= 0
Const HELPER_RIGHT:Int				= 1
Const HELPER_LEFT_THRESHOLD:Int		= 50
Const HELPER_RIGHT_THRESHOLD:Int	= 70
Const HELPER_LEFT_X:Int				= -128
Const HELPER_LEFT_Y:Int				= 128
Const HELPER_RIGHT_X:Int			= 128
Const HELPER_RIGHT_Y:Int			= -128
Const HELPER_SLIDE_EXTRA:Int		= 128
Const HELPER_HEAL:Int				= 15
Const HELPER_HEALINTERVAL:Int		= 300
Const HELPER_SPAWNTIME:Int			= 100
Const HELPER_RETRACTTIME:Int		= 100
Const HELPER_LEFT_MOTION_VEL:Int	= 180
Const HELPER_LEFT_MOTION_AMP_Y:Int	= 16
Const HELPER_RIGHT_MOTION_VEL:Int	= 180
Const HELPER_RIGHT_MOTION_AMP_X:Int	= 16
Const HELPER_RIGHT_MOTION_AMP_Y:Int	= 8
Const HELPER_HEAL_BLINKTIME:Int		= 100
Global HELPER_HEAL_COLOR:Int[]		= [0,255,0]
' tokens
Const TOKEN_CNT:Int					= 3
Const TOKEN_X:Int					= 224
Const TOKEN_Y:Int					= 192
Const TOKEN_MAX_COLL:Int			= 3
Const TOKEN_MOTION_DECAY:Int		= 500
Const TOKEN_MOTION_VEL:Int			= 720
Const TOKEN_LIFETIME:Int			= 2000
Const TOKEN_BLINKTIME:Int			= 1500
Const TOKEN_BLINKVEL:Int			= 3600
Const TOKEN_BLINK_BASE:Float		= 0.6
Const TOKEN_BLINK_AMP:Float			= 0.4
Const TOKEN_SHADOW_Y:Int			= 32
' over head texts
Const OHTEXT_DAMAGE:Int				= 0
Const OHTEXT_HEAL:Int				= 1
Const OHTEXT_Y:Int					= -200
Const OHTEXT_VEL_X:Float			= 0
Const OHTEXT_VEL_Y:Float			= -3
Const OHTEXT_LIFETIME:Int			= 1000
Global OHTEXT_COL_DAMAGE:Int[]		= [255,0,0]
Global OHTEXT_COL_HEAL:Int[]		= [0,255,0]
' attack
Const ATTACK_STANDARD:Int			= 10
Const ATTACK_ADDITIONAL_DAMAGE:Int	= 20
Const ATTACK_ULTRA_DAMAGE:Int		= 50
' special attacks
Const SPECIAL_IDLE:Int				= 0
Const SPECIAL_KILL:Int				= 1
Const SPECIAL_ADDITIONAL_DAMAGE:Int	= 2
Const SPECIAL_ULTRA_DAMAGE:Int		= 3
Const SPECIAL_ATTACK_DURATION:Int	= 2000
Const SPECIAL_BLINKTIME:Int			= 1500
Const SPECIAL_MOTION_VEL:Int		= 1800
Const SPECIAL_MOTION_BASE:Float		= 0.9
Const SPECIAL_MOTION_AMP:Float		= 0.1
Const SPECIAL_BLINK_VEL:Int			= 3600
Const SPECIAL_BLINK_BASE:Float		= 0.6
Const SPECIAL_BLINK_AMP:Float		= 0.4
Global SPECIAL_COLOR:Int[]			= [192,160,0]
' level settings
Const LEVELS:Int					= 10
Global MONSTER_COUNTS:Int[]			= [1,1,2,2,2,3,3,3,3,3]	' must have LEVELS entries
Global HELPER_COUNTS:Int[]			= [0,1,1,2,3,2,3,4,5,6]	' must have LEVELS entries
' miscellaneous
Const HIGHSCORE_ENTRIES:Int				= 10
Const HIGHSCORE_DEFAULT_NAME:String		= "-"
Const HIGHSCORE_DEFAULT_TIME:Int		= 119.99 *1000
Const HIGHSCORE_NAME_MAXLENGTH:Int		= 20
Const TIME_WARMUP:Int					= 5000
Const TIME_COOLDOWN:Int					= 3000
Const TIME_QUIT:Int						= 200
Const ALPHA_THREASHOLD:Int				= 64

' really really global stuff
Global mx:Int, my:Int, mhit:Int, attack:Int
Global ms:Int
Global font:TFont = New TFont.Init("gfx/font")
Global highscore:THighscore[] = THighscore.Load()

AppTitle = "Deathclick"

Game.Load()

App.Main()
End

' application (mostly state machine)
Type App
	Global timer:TTimer = CreateTimer(HERTZ)
	' game states and intermediate states
	Global state:Int				= STATE_MENU
	Global state_next:Int
	Global statefade:Int			= STATEFADE_IN
	Global statefade_value:Float	= STATEFADE_MAXVALUE
	
	' run state machine
	Function Main()
		SeedRnd(MilliSecs())
		
		Graphics(SCREEN_WIDTH, SCREEN_HEIGHT)
		SetClsColor(COLOR_BACKGROUND[0], COLOR_BACKGROUND[1], COLOR_BACKGROUND[2])
		SetBlend ALPHABLEND
	
		' main loop
		While Not AppTerminate()
			Cls
			
			' input
			ms = MilliSecs()
			mx = MouseX()
			my = MouseY()
			mhit = MouseHit(MOUSE_LEFT)
			
			' processing
			UpdateStates()
			
			Select state
			Case STATE_MENU
				Menu.Run()
			Case STATE_GAME
				Game.Run()
			Case STATE_ENTERNAME
				Gameover.Run(True)
			Case STATE_GAMEOVER
				Gameover.Run()
			Case STATE_END
				Delay TIME_QUIT
				End
			End Select
		
			WaitTimer(timer)
			Flip 0
		Wend
	
	End Function
	
	' update state machine
	' control fades, switch states
	Function UpdateStates()
		' process fade
		Select statefade
		' fade in
		Case STATEFADE_IN
			statefade_value :- STATEFADE_STEPVALUE
			' switch to idle
			If statefade_value <= 0 then
				statefade_value = 0
				statefade = STATEFADE_IDLE
			EndIf
		' fade out
		Case STATEFADE_OUT
			statefade_value :+ STATEFADE_STEPVALUE
			' switch state, fade in
			If statefade_value >= STATEFADE_MAXVALUE then
				statefade_value = STATEFADE_MAXVALUE
				statefade = STATEFADE_IN
				state = state_next
			EndIf
		End Select
	End Function
	
	' switch state via intermediate state
	Function ChangeState(pState:Int)
		state_next = pState
		statefade = STATEFADE_OUT
	End Function
End Type

' menu namespace
Type Menu
	' main menu
	Function Run()
		' draw buttons
		FadeVertically(0)
		If Button("Start Game", 4 * SCREEN_UNIT, 11 * SCREEN_VUNIT) Then
			App.ChangeState(STATE_GAME)
			Game.ResetGame()
		EndIf
		FadeVertically(0.1)
		If button("Quit Game", 12 * SCREEN_UNIT, 11 * SCREEN_VUNIT) Or KeyHit(KEY_ESCAPE) then
			App.ChangeState(STATE_END)
		EndIf
		' draw highscore
		FadeVertically(1)
		SetScale(1,1)
		SetCol(COLOR_MENU_TEXT)
		font.Draw("Highscore", 8 * SCREEN_UNIT, 1 * SCREEN_VUNIT, ALIGN_CENTER, ALIGN_CENTER)
		SetScale(0.6, 0.6)
		For Local i:Int = 0 Until HIGHSCORE_ENTRIES
			FadeVertically(1 -i *0.8 / HIGHSCORE_ENTRIES)
			Local y:Float = (3 +i *6.0 / (HIGHSCORE_ENTRIES -1)) * SCREEN_VUNIT
			If highscore[i].isnew Then
				SetCol(COLOR_HIGHSCORE_NEW)
			Else
				SetCol(COLOR_MENU_TEXT)
			EndIf
			font.Draw(highscore[i].name, 3 * SCREEN_UNIT, y, ALIGN_LEFT, ALIGN_CENTER)
			font.Draw(FormatTime(highscore[i].time), 13 * SCREEN_UNIT, y, ALIGN_RIGHT, ALIGN_CENTER)
		Next
		SetScale(1,1)
		SetOrigin(0,0)
	End Function
End Type

' game over / enter name namespace
Type Gameover
	Global name:String = "Player"
	' menu to enter name
	Function Run(pEnterName:Int=False)
		Local char:Byte
		' type in name
		If pEnterName then
			char = GetChar()
			If char = 8 And name.length > 0 then
				name = name[..name.length-1]
			ElseIf char >= 32 And name.length < HIGHSCORE_NAME_MAXLENGTH then
				name :+ Chr(char)
			EndIf
		EndIf

		' time
		FadeVertically(1)
		SetScale(1,1)
		SetCol(COLOR_MENU_HIGHLIGHT)
		font.Draw("YOU WON!", 8 * SCREEN_UNIT, 2 * SCREEN_VUNIT, ALIGN_CENTER, ALIGN_CENTER)
		
		FadeVertically(0.9)
		SetCol(COLOR_MENU_TEXT)
		SetScale(0.8, 0.8)
		font.Draw("Your Time:", 8 * SCREEN_UNIT, 4 * SCREEN_VUNIT, ALIGN_CENTER, ALIGN_CENTER)
		
		FadeVertically(0.8)
		SetCol(COLOR_MENU_HIGHLIGHT)
		SetScale(1,1)
		font.Draw(FormatTime(Game.playtime), 8 * SCREEN_UNIT, 5 * SCREEN_VUNIT, ALIGN_CENTER, ALIGN_CENTER)
		
		' name entry
		If pEnterName then
			FadeVertically(0.6)
			SetScale(0.8, 0.8)
			SetCol(COLOR_MENU_TEXT)
			font.Draw("New Highscore! Enter Your Name:", 8 * SCREEN_UNIT, 7 * SCREEN_VUNIT, ALIGN_CENTER, ALIGN_CENTER)
			
			FadeVertically(0.5)
			SetScale(1,1)
			SetCol(COLOR_NAME_INPUT)
			Local tempname:String = name
			If name.length < HIGHSCORE_NAME_MAXLENGTH then
				tempname :+ "_"
			EndIf
			font.Draw(tempname, 4 * SCREEN_UNIT, 8 * SCREEN_UNIT, ALIGN_LEFT, ALIGN_CENTER)
		EndIf
		' button
		FadeVertically(0)
		If button("OK", 8 * SCREEN_UNIT, 11 * SCREEN_VUNIT) Or char = 13 Or KeyHit(KEY_ESCAPE) then
			THighscore.Enter(name, Game.playtime)
			App.ChangeState(STATE_MENU)
		EndIf
	End Function
End Type

' game namespace
Type Game
	Global monster_faces:TGameObjectFace[7]
	Global helper_faces:TGameObjectFace[2]
	Global token_faces:TGameObjectFace[3]
	Global layers:TGameObjectLayer[LAYER_CNT]
	Global img_specialattack:TImage
	Global img_background:TImage
	Global img_shadow:TImage
	Global img_shadow_token:TImage
	Global img_countdown:TImage

	' game vars
	Global level:Int
	Global time_start:Int
	Global tokens:Int[TOKEN_MAX_COLL], tokens_coll:Int
	Global special:Int, special_time:Int
	Global gametime:Int, playtime:Int, exittime:Int
	Global running:Int

	' load media and init data
	Function Load()
		' load monster images
		For Local i:Int = 0 Until MONSTER_CNT
			monster_faces[i] = New TGameObjectFace.Init("gfx/monster"+i+".png")
		Next
		For Local i:Int = 0 Until HELPER_CNT
			helper_faces[i] = New TGameObjectFace.Init("gfx/helper"+i+".png")
		Next
		For Local i:Int = 0 Until TOKEN_CNT
			token_faces[i] = New TGameObjectFace.Init("gfx/token"+i+".png")
		Next
		' load extra media
		img_specialattack = LoadImage("gfx/special.png")
		MidHandleImage(img_specialattack)
		img_background = LoadImage("gfx/background.png")
		img_shadow = LoadImage("gfx/shadow.png")
		MidHandleImage(img_shadow)
		img_shadow_token = LoadImage("gfx/shadow_token.png")
		MidHandleImage(img_shadow_token)
		img_countdown = LoadAnimImage("gfx/countdown.png", 128, 128, 0, 3)
		MidHandleImage(img_countdown)
	End Function

	' reset all stats for a new game
	Function ResetGame()
		level		= 0
		time_start	= ms + TIME_WARMUP
		tokens		= [-1,-1,-1]
		tokens_coll	= 0
		special		= SPECIAL_IDLE
		special_time= 0
		playtime	= 0
		exittime	= 0
		running		= True
		' init layers
		For Local i:Int = 0 Until LAYER_CNT
			layers[i] = New TGameObjectLayer.Init()
		Next
	End Function

	' update and draw
	Function Run()
		' control game time and playtime
		gametime = ms -time_start
		' playtime
		If exittime = 0 then
			If gametime >= 0 then
				playtime = gametime
			EndIf
		' game over
		Else
			If ms > exittime Then
				running = False
				THighscore.UnNewAll()
				If THighscore.IsRankedTime(playtime) then
					App.ChangeState(STATE_ENTERNAME)
				Else
					App.ChangeState(STATE_GAMEOVER)
				EndIf
			EndIf
		EndIf
		
		' abort game
		If KeyHit(KEY_ESCAPE) then
			App.ChangeState(STATE_MENU)
		EndIf
		
		' spawn monsters
		If gametime >= 0 then
			' spawn one, if no monster is left
			If CountMonsters() = 0 then
				' level up
				If level < LEVELS then
					' spawn monster
					Local cnt:Int = MONSTER_COUNTS[level]
					For Local i:Int = 0 Until cnt
						SpawnRandomMonster()
					Next
					' spawn helpers
					cnt = HELPER_COUNTS[level]
					For Local i:Int = 0 Until cnt
						' find a free position for helper to spawn
						SpawnRandomHelper()
					Next
					level :+ 1
				' end of game
				ElseIf exittime = 0 then
					exittime = ms + TIME_COOLDOWN
				EndIf
			EndIf
		EndIf

		' update layers
		' attack will be unset, as soon a object got hit, so only one
		' object can get hit with one mousehit
		attack = mhit
		' go backwards through layers, front objects have higher priority
		For Local i:Int = LAYER_CNT -1 To 0 Step -1
			layers[i].Update()
		Next
		
		CheckTokenSpecial()
		
		' draw background
		FadeVertically(1)
		SetCol(COLOR_WHITE)
		DrawImage(img_background,0,0)
		
		' draw shadows
		For Local i:Int = 0 Until LAYER_CNT
			layers[i].DrawShadows()
		Next
		
		' draw layers
		For Local i:Int = 0 Until LAYER_CNT
			layers[i].Draw()
		Next
		
		' draw hud
		SetCol(COLOR_HUD)
		FadeVertically(0)
		font.Draw("Level " +level, 1 * SCREEN_UNIT, 11 * SCREEN_VUNIT, ALIGN_LEFT, ALIGN_CENTER)
		FadeVertically(0.5)
		font.Draw(FormatTime(playtime), 15 * SCREEN_UNIT, 11 * SCREEN_VUNIT, ALIGN_RIGHT, ALIGN_CENTER)
		SetCol(COLOR_WHITE)
		For Local i:Int = 0 Until TOKEN_MAX_COLL
			FadeVertically(0.7 +i/10.0)
			If tokens[i] >= 0 then
				DrawImage(token_faces[tokens[i]].image, (8 -(TOKEN_MAX_COLL -1) /2 +i) * SCREEN_UNIT, 11 * SCREEN_VUNIT)
			EndIf
		Next
		' special attack indicator
		If special <> SPECIAL_IDLE then
			SetCol(SPECIAL_COLOR)
			FadeVertically(0.8)
			SetBlend LIGHTBLEND
			Local phi:Float = ms /1000.0 * SPECIAL_MOTION_VEL
			Local scale:Float = SPECIAL_MOTION_BASE + sin(phi) * SPECIAL_MOTION_AMP
			SetScale(scale, scale)
			Local dt:Int = ms -special_time + SPECIAL_ATTACK_DURATION
			If dt > SPECIAL_BLINKTIME then
				phi = dt /1000.0 * SPECIAL_BLINK_VEL
				Local alpha:Float = SPECIAL_BLINK_BASE + sin(phi) * SPECIAL_BLINK_AMP
				SetAlpha(alpha)
			EndIf
			DrawImage(img_specialattack, 8 * SCREEN_UNIT, 11 * SCREEN_VUNIT)
			SetBlend ALPHABLEND
			SetScale(1,1)
			SetAlpha(1)
		EndIf
		
		' draw countdown
		If gametime < 0 then
			Local cnt:Int = -gametime /1000
			' only draw last seconds of countdown
			If cnt <= 2 then
				SetCol(COLOR_COUNTDOWN)
				DrawImage(img_countdown, 8 * SCREEN_UNIT, 7 * SCREEN_VUNIT, cnt)
			EndIf
		EndIf
	End Function

	' check tokens, init special action
	' 3 different	- instakill next monster
	' 2 same		- little extra damage
	' 3 same		- some extra damage
	Function CheckTokenSpecial()
		' start special attack
		If special_time = 0 then
			If tokens_coll = TOKEN_MAX_COLL then
				' count tokens
				Local counts:Int[TOKEN_CNT]
				For Local i:Int = 0 Until TOKEN_MAX_COLL
					counts[tokens[i]] :+ 1
				Next
				' define case
				Local maxcount:Int = 0
				For Local i:Int = 0 Until TOKEN_CNT
					If counts[i] > maxcount then maxcount = counts[i]
				Next
				' init special action
				Select maxcount
				Case 1
					special = SPECIAL_ULTRA_DAMAGE
				Case 2
					special = SPECIAL_ADDITIONAL_DAMAGE
				Case 3
					special = SPECIAL_KILL
				End Select
				special_time = ms + SPECIAL_ATTACK_DURATION
			EndIf
		' end special attack
		ElseIf ms > special_time then
			' remove tokens if special attack was used
			tokens = [-1,-1,-1]
			tokens_coll = 0
			special = SPECIAL_IDLE
			special_time = 0
		EndIf
	End Function

	' counts how many monsters are still alive
	Function CountMonsters:Int()
		Local cnt:Int = 0
		For Local i:Int = 0 Until LAYER_CNT
			If layers[i].monster then cnt :+ 1
		Next
		Return cnt
	End Function
	
	' counts how many helpers are active
	Function CountHelpers:Int()
		Local cnt:Int = 0
		For Local i:Int = 0 Until LAYER_CNT
			cnt :+ layers[i].helpers.Count()
		Next
		Return cnt
	End Function
	
	' spawn monster at random, free position
	Function SpawnRandomMonster()
		' spawning will fail if no available positions are left
		If CountMonsters() = MONSTER_POS_CNT then Return
		' otherwise, it's save to go for it
		Local idx:Int
		Repeat
			idx = Rand(0, MONSTER_POS_CNT -1)
			If Not layers[idx].monster then
				Local monster:TMonster = New TMonster.Init(monster_faces[ Rand(0,6) ], layers[idx])
				monster.Position(MONSTER_POSITIONS[idx][0], MONSTER_POSITIONS[idx][1])
				Return
			EndIf
		Forever
	End Function
	
	' spawn helper at random, free position
	Function SpawnRandomHelper()
		Local pos:Int, class:Int
		' spawning will fail if no available places are left
		Local cnt:Int = 0
		For pos = 0 Until MONSTER_POS_CNT
			For class = 0 To 1
				If HelperPlaceAvailable(pos, class) then
					cnt :+ 1
				EndIf
			Next
		Next
		If cnt = 0 then Return
		' otherwise, it's save to go for it
		Repeat
			pos = Rand(0, MONSTER_POS_CNT -1)
			class = Rand(0,1)
			If HelperPlaceAvailable(pos, class) then
				New THelper.Init(class, layers[pos])
				Return
			EndIf
		Forever
	End Function
	
	' checks if the place is free
	Function HelperPlaceAvailable:Int(pPos:Int, pClass:Int)
		' it's not, if no monster exists at this position
		If Not layers[pPos].monster then Return False
		' otherwise it's only, if no monster of that class exists
		For Local helper:THelper = EachIn layers[pPos].helpers
			If helper.class = pClass then Return False
		Next
		' if it didn't fail till here, place is free
		Return True
	End Function
End Type

' layers for game objects
' used for z-ordering and storing monsters, helpers, tokens and OH-texts
Type TGameObjectLayer
	Field monster:TMonster
	Field helpers:TList
	Field tokens:TList
	Field ohtexts:TList
	
	' initialise layer
	Method Init:TGameObjectLayer()
		monster		= Null
		helpers		= CreateList()
		tokens		= CreateList()
		ohtexts		= CreateList()
		Return Self
	End Method
	
	' update layer objects
	Method Update()
		' first, update and check tokens
		For Local token:TToken = EachIn tokens
			token.Update()
		Next
		' second, update and check monster
		If monster then monster.Update()
		' third, update and check helpers
		For Local helper:THelper = EachIn helpers
			helper.Update()
		Next
		' last, update oh texts
		For Local ohtext:TOHText = EachIn ohtexts
			ohtext.Update()
		Next
	End Method
	
	' draw layer objects
	Method Draw()
		' first, draw helpers
		For Local helper:THelper = EachIn helpers
			helper.Draw()
		Next
		' second, draw monsters
		If monster then monster.Draw()
		' third, draw tokens
		For Local token:TToken = EachIn tokens
			token.Draw()
		Next
		' last, draw oh texts
		For Local ohtext:TOHText = EachIn ohtexts
			ohtext.Draw()
		Next
	End Method
	
	' draw layer objects shadows
	Method DrawShadows()
		SetBlend SHADEBLEND
		If monster then monster.DrawShadow()
		For Local token:TToken = EachIn tokens
			token.DrawShadow()
		Next
		SetBlend ALPHABLEND
	End Method
End Type

' images shared across TGameObjects
Type TGameObjectFace
	Field image:TImage
	Field pixmap:TPixmap
	
	' initialise face
	' load face image
	Method Init:TGameObjectFace(pUrl:Object)
		image = LoadImage(pUrl)
		MidHandleImage(image)
		pixmap = LockImage(image,0, True, False)
		Return Self
	End Method
	
	' checks if coordinates are visible pixel
	Method Collides:Byte(pX:Int, pY:Int)
		' since the image is mid-handled, move coordinates
		pX :+ pixmap.width /2
		pY :+ pixmap.height /2
		' only check inside bounding box
		If pX >= 0 And pX < pixmap.width And pY >= 0 And pY < pixmap.height then
			Local argb:Int = pixmap.ReadPixel(pX, pY)
			' extract alpha value
			Local a:Int = argb Shr 24
			' count as hit if alpha is at least threshold
			If a > ALPHA_THREASHOLD then
				Return True
			EndIf
		EndIf
		Return False
	End Method
End Type

' abstract type for all game objects
Type TGameObject Abstract
	Field face:TGameObjectFace
	Field width:Int, height:Int
	' position of origin
	Field pos_x:Int, pos_y:Int
	Field fine_x:Float, fine_y:Float
	Field layer:TGameObjectLayer
	' drawing position
	Field x:Float, y:Float
	
	' set objects face
	Method SetFace(pFace:TGameObjectFace)
		face = pFace
	End Method
	
	' set the position of the object
	' coordinates are SCREEN_UNIT / SCREEN_VUNIT
	Method Position(pU:Float, pV:Float)
		pos_x = pU * SCREEN_UNIT
		pos_y = pV * SCREEN_VUNIT
		fine_x = 0
		fine_y = 0
		x = pos_x
		y = pos_y
	End Method
	
	' update object
	' mostly: adapt drawing position
	Method Update()
		x = pos_x +fine_x
		y = pos_y +fine_y
	End Method
	
	' checks if the object was hit on a visible pixel
	' pCheck: only check if true
	Method Hit:Byte(pCheck:Int)
		' abort if mouse wasnt hit
		If Not pCheck then Return False
		' mouse coordinates relative to image
		Local dx:Int = mx -x
		Local dy:Int = my -y
		' check pixel
		Return face.Collides(dx,dy)
	End Method
	
	' draw game object
	Method Draw()
		DrawImage(face.image, x, y)
	End Method
End Type

Type TMonster Extends TGameObject
	Field health:Int = MONSTER_HEALTH
	Field hittime:Int
	Field motion_offset:Int
	
	' initialise monster and set face
	Method Init:TMonster(pFace:TGameObjectFace, pLayer:TGameObjectLayer)
		layer = pLayer
		layer.monster = Self
		SetFace(pFace)
		motion_offset = Rand(0,359)
		Return Self
	End Method
	
	Method Update()
		' check for attack
		If Hit(attack) then
			attack = 0
			' define damage dealt by special attack type
			Local damage:Int
			Select Game.special
			Case SPECIAL_ADDITIONAL_DAMAGE
				damage = ATTACK_ADDITIONAL_DAMAGE
			Case SPECIAL_ULTRA_DAMAGE
				damage = ATTACK_ULTRA_DAMAGE
			Case SPECIAL_KILL
				damage = health
			Default
				damage = ATTACK_STANDARD
			End Select
			' deal damage
			health :- damage
			hittime = ms
			New TOHText.Init(damage, x, y, OHTEXT_DAMAGE, layer)
			' monster defeated, remove and spawn token
			If health <= 0 then
				New TToken.Init(Rand(0, TOKEN_CNT -1), layer)
				layer.monster = Null
			EndIf
		EndIf
	
		' motion
		Local dt:Float = ms /1000.0 * MONSTER_MOTION_VEL +motion_offset
		fine_x = sin(dt) * MONSTER_MOTION_AMP_X
		fine_y = sin(dt *2) * MONSTER_MOTION_AMP_Y
		
		Super.Update()
	End Method
	
	' draw monster
	Method Draw()
		SetCol(COLOR_WHITE)
		' time since hit, interpolated from 0 .. 1
		Local f:Float = Float(ms -hittime) / MONSTER_HIT_BLINKTIME
		' blink
		If f < 1 then
			SetColInterp(MONSTER_HIT_COLOR, COLOR_WHITE, f)
		EndIf
		Super.Draw()
		' healthbar
		f = Float(health) / MONSTER_HEALTH
		SetCol(HEALTHBAR_COLOR)
		DrawRect(x +HEALTHBAR_X -fine_x, y +HEALTHBAR_Y, f * HEALTHBAR_WIDTH, HEALTHBAR_HEIGHT)
	End Method
	
	Method DrawShadow()
		DrawImage(Game.img_shadow, x, y + MONSTER_SHADOW_Y)
	End Method
End Type

Type THelper Extends TGameObject
	Field class:Int
	Field health_threshold:Int
	Field motion_offset:Int
	Field slide_distance:Int
	Field healtime:Int, fxtime:Int
	
	Const STATE_HIDE:Int	= 0
	Const STATE_SPAWN:Int	= 1
	Const STATE_LIVE:Int	= 2
	Const STATE_RETRACT:Int	= 3
	Field state:Int = STATE_HIDE
	Field state_time:Int
	
	' initialise helper
	' pClass: class is HELPER_LEFT or HELPER_RIGHT
	' pLayer: the layer of the monster, the helper helps
	Method Init:THelper(pClass:Int, pLayer:TGameObjectLayer)
		class	= pClass
		layer	= pLayer
		' position according to class
		Local monster:TMonster = layer.monster
		If class = HELPER_LEFT then
			pos_x = monster.pos_x + HELPER_LEFT_X
			pos_y = HELPER_LEFT_Y
			health_threshold = HELPER_LEFT_THRESHOLD
		Else
			pos_x = monster.pos_x + HELPER_RIGHT_X
			pos_y = monster.pos_y + HELPER_RIGHT_Y
			health_threshold = HELPER_RIGHT_THRESHOLD
		EndIf
		' random motion offset
		motion_offset = Rand(0,359)
		slide_distance = pos_y + HELPER_SLIDE_EXTRA
		
		SetFace(Game.helper_faces[class])
		layer.helpers.AddLast(Self)
		Super.Update()
		Return Self
	End Method
		
	Method Update()
		Local slide:Float
		' tiny state machine
		Select state
		Case STATE_HIDE
			' remove, if monster stopped to exist
			If Not layer.monster then
				layer.helpers.Remove(Self)
			EndIf
			' if monsters health is below threshold, spawn
			If layer.monster And layer.monster.health < health_threshold then
				state = STATE_SPAWN
				state_time = ms +HELPER_SPAWNTIME
			EndIf
			slide = 1
		Case STATE_SPAWN
			Local dt:Float = ms -state_time
			If dt > 0 then
				dt = 0
				state = STATE_LIVE
				healtime = ms + HELPER_HEALINTERVAL
			EndIf
			slide = dt / HELPER_SPAWNTIME
		Case STATE_LIVE
			' go away if attacked
			If Hit(attack) then
				attack = 0
				state = STATE_RETRACT
				state_time = ms
			EndIf
			' go away if monster is missing
			If Not layer.monster Or layer.monster.health = 0 then
				state = STATE_RETRACT
				state_time = ms
			EndIf
			' heal from time to time
			If layer.monster And ms >= healtime then
				healtime :+ HELPER_HEALINTERVAL
				fxtime = ms
				' old health of monster
				Local health:Int = layer.monster.health
				' heal to max health
				If layer.monster.health < MONSTER_HEALTH then
					layer.monster.health :+ HELPER_HEAL
					If layer.monster.health > MONSTER_HEALTH then
						layer.monster.health = MONSTER_HEALTH
					EndIf
					' display healed value
					Local healed:Int = layer.monster.health -health
					New TOHText.Init(healed, layer.monster.x, layer.monster.y, OHTEXT_HEAL, layer)
				EndIf
			EndIf
		Case STATE_RETRACT
			Local dt:Float = ms -state_time
			If dt > HELPER_RETRACTTIME then
				layer.helpers.Remove(Self)
			EndIf
			slide = dt / HELPER_RETRACTTIME
		End Select
	
		' motion
		If class = HELPER_LEFT then
			Local dt:Float = ms /1000.0 * HELPER_LEFT_MOTION_VEL +motion_offset
			fine_y = -Abs(sin(dt) * HELPER_LEFT_MOTION_AMP_Y)
		Else
			Local dt:Float = ms /1000.0 * HELPER_RIGHT_MOTION_VEL +motion_offset
			fine_x = cos(dt) * HELPER_RIGHT_MOTION_AMP_X
			fine_y = sin(dt*2) * HELPER_RIGHT_MOTION_AMP_Y
		EndIf
		
		' slide in and out
		fine_y :- slide^2 *slide_distance
		
		Super.Update()
	End Method
	
	Method Draw()
		SetCol(COLOR_WHITE)
		' time since heal, interpolated from 0 .. 1
		Local f:Float = Float(ms -healtime + HELPER_HEALINTERVAL) / HELPER_HEAL_BLINKTIME
		' blink
		If f < 1 then
			SetColInterp(HELPER_HEAL_COLOR, COLOR_WHITE, f)
		EndIf
		Super.Draw()
	End Method
End Type

' tokens
Type TToken Extends TGameObject
	Field class:Int
	Field time:Int
	Field dir:Int
	
	Method Init:TToken(pClass:Int, pLayer:TGameObjectLayer)
		class	= pClass
		layer	= pLayer
		time = ms
		' set position to layers monster position
		pos_x = layer.monster.pos_x
		pos_y = layer.monster.pos_y + TOKEN_Y
		dir = 1
		If Rand(0,1) then dir = -dir
		SetFace(Game.token_faces[class])
		layer.tokens.AddLast(Self)
		Super.Update()
		Return Self
	End Method
	
	Method Update()
		' give to player if hit
		If Game.tokens_coll < TOKEN_MAX_COLL And Hit(attack) then
			attack = False
			Game.tokens[Game.tokens_coll] = class
			Game.tokens_coll :+ 1
			layer.tokens.Remove(Self)
			Return
		EndIf
		' remove if time ran out
		If ms > (time + TOKEN_LIFETIME) then
			layer.tokens.Remove(Self)
			Return
		EndIf
		
		' motion
		Local dt:Float = ms -time
		Local amp:Float = exp(-dt / TOKEN_MOTION_DECAY)
		Local phi:Float = dt /1000.0 * TOKEN_MOTION_VEL
		fine_x = TOKEN_X *dir *(1 -amp)
		fine_y = -Abs(cos(phi) *amp *TOKEN_Y)
		
		Super.Update()
	End Method
	
	Method Draw()
		SetCol(COLOR_WHITE)
		' blink if time is running out
		Local dt:Int = ms -time
		If dt >= TOKEN_BLINKTIME then
			Local phi:Float = dt /1000.0 * TOKEN_BLINKVEL
			Local alpha:Float = TOKEN_BLINK_BASE +cos(phi) * TOKEN_BLINK_AMP
			SetAlpha(alpha)
		EndIf
		Super.Draw()
		SetAlpha(1)
	End Method
	
	Method DrawShadow()
		DrawImage(Game.img_shadow_token, x, pos_y + TOKEN_SHADOW_Y)
	End Method
End Type

' over head texts
Type TOHText
	Field txt:String
	Field x:Float, y:Float
	Field class:Int
	Field time:Int
	Field layer:TGameObjectLayer
	
	Method Init:TOHText(pText:String, pX:Int, pY:Int, pClass:Int, pLayer:TGameObjectLayer)
		txt		= pText
		x		= pX
		y		= pY + OHTEXT_Y
		class	= pClass
		layer	= pLayer
		time = ms + OHTEXT_LIFETIME
		layer.ohtexts.AddLast(Self)
		Return Self
	End Method
	
	Method Update()
		' remove when time is over
		If ms >= time then
			layer.ohtexts.Remove(Self)
		EndIf
		' motion
		x :+ OHTEXT_VEL_X
		y :+ OHTEXT_VEL_Y
	End Method
	
	Method Draw()
		Select class
		Case OHTEXT_DAMAGE
			SetCol(OHTEXT_COL_DAMAGE)
		Case OHTEXT_HEAL
			SetCol(OHTEXT_COL_HEAL)
		End Select
		font.Draw(txt, x,y, ALIGN_CENTER, ALIGN_CENTER)
	End Method
End Type

' highscore type, a pair of name and time
Type THighscore
	Field name:String	= HIGHSCORE_DEFAULT_NAME
	Field time:Int		= HIGHSCORE_DEFAULT_TIME
	Field isnew:Byte	= False
	
	Method Init:THighscore(pName:String, pTime:Int)
		name	= pName
		time	= pTime
		isnew	= True
		Return Self
	End Method
	
	' load highscore or fill with empty entries
	Function Load:THighscore[]()
		Local highscore:THighscore[HIGHSCORE_ENTRIES]
		' fill with defaults
		For Local i:Int = 0 Until HIGHSCORE_ENTRIES
			highscore[i] = New THighscore
		Next
		' read in from file
		Local file:TStream = ReadFile("highscore.dat")
		If file Then
			Local idx:Int = 0, datatype:Int = 0
			Local txt:String
			While Not file.Eof()
				txt = file.ReadLine()
				If datatype = 0 Then
					highscore[idx].name = txt
					datatype = 1
				Else
					highscore[idx].time = Int(txt)
					datatype = 0
					idx :+ 1
				EndIf
			Wend
			file.Close()
		EndIf
		Return highscore
	End Function
	
	' save highscore
	Function Save()
		Local file:TStream = WriteFile("highscore.dat")
		For Local i:Int = 0 Until HIGHSCORE_ENTRIES
			file.WriteLine(highscore[i].name)
			file.writeline(highscore[i].time)
		Next
		file.Close()
	End Function
	
	Function UnNewAll()
		For Local i:Int = 0 Until HIGHSCORE_ENTRIES
			highscore[i].isnew = False
		Next
	End Function
	
	' enter score into list
	Function Enter(pName:String, pTime:Int)
		Local highscore_temp:THighscore[] = New THighscore[HIGHSCORE_ENTRIES]
		Local idx_temp:Int = 0, idx:Int = 0
		Local entered:Int = False
		While idx_temp < HIGHSCORE_ENTRIES
			If pTime < highscore[idx].time And Not entered Then
				highscore_temp[idx_temp] = New THighscore.Init(pName, pTime)
				idx_temp :+ 1
				entered = True
			EndIf
			highscore_temp[idx_temp] = highscore[idx]
			idx_temp :+ 1
			idx :+ 1
		Wend
		highscore = highscore_temp
		Save()
	End Function
	
	' check if time is highscore worthy
	Function IsRankedTime:Int(pTime:Int)
		For Local i:Int = 0 Until HIGHSCORE_ENTRIES
			If pTime < highscore[i].time Then
				Return True
			EndIf
		Next
		Return False
	End Function
End Type

Const ALIGN_LEFT:Int	= 0
Const ALIGN_CENTER:Int	= 1
Const ALIGN_RIGHT:Int	= 2
Const ALIGN_TOP:Int		= 0
Const ALIGN_BASELINE:Int= 2
' image font, simplified
Type TFont
	Field image:TImage, cellsize:Int
	Field offset_x:Int, offset_y:Int, spacing:Int, fontheight:Int
	Field widths:Int[] = New Int[256]
	
	' loads a font, pName.png and pName.dat must exist!
	Method Init:TFont(pName:String)
		' first: read font info (.dat) file, containing char widths, cell size and x/y offset
		Local file:TStream = ReadFile(pName +".dat")
		Local char:Byte, buffer:String, value:Int
		Local eot:Byte=False ' used to indicate end of text (white space or file ending)
		Local idx:Int = 0
		' read as long as there is data in file
		While Not file.Eof()
			char = file.ReadByte()
			' numerical char 48 == ascii:0, 57 == ascii:9
			If char >= 48 And char <= 57 then
				' add char to buffer
				buffer :+ Chr(char)
				eot = False
			Else
				eot = True
			EndIf
			' set end of text at end of file
			If file.Eof() then eot=True
			' any other char
			If eot = True And buffer <> "" then
				' read integer value from buffer
				value = Int(buffer)
				' depending on idx, interpret
				Rem
					0...255		width
					256			cellsize
					257,258		x/y-offset
					259			spacing
					260			font height
				end Rem
				If idx <= 255 then
					widths[idx] = value
				ElseIf idx = 256 then
					cellsize = value
				ElseIf idx = 257 then
					offset_x = value
				ElseIf idx = 258 then
					offset_y = value
				ElseIf idx = 259 then
					spacing = value
				ElseIf idx = 260 then
					fontheight = value
				EndIf
				' get ready for next value
				buffer = ""
				idx :+ 1
			EndIf
		Wend
		file.Close()
		' second: load image file
		image = LoadAnimImage(pName +".png", cellsize, cellsize, 0, 256)
		Return self
	End Method
	
	' draw a text
	Method Draw(pText:String, pX:Float, pY:Float, pHorizontalAlign:Int=0, pVerticalAlign:Int=ALIGN_BASELINE)
		' ^ due to possible scaling, use float for position
		' save active scaling
		Local scale_x:Float, scale_y:Float
		GetScale(scale_x, scale_y)
		' remove offset_x (aka the white space left of each char)
		pX :- offset_x *scale_x
		' position according to horizontal aligning
		If pHorizontalAlign = ALIGN_CENTER
			pX :- GetWidth(pText) *0.5 *scale_x
		ElseIf pHorizontalAlign = ALIGN_RIGHT
			pX :- GetWidth(pText) *scale_x
		EndIf
		' remove offset_y
		pY :- offset_y *scale_y
		' position according to vertical aligning
		If pVerticalAlign = ALIGN_CENTER
			pY :+ GetHeight(pText) *0.5 *scale_y
		ElseIf pVerticalAlign = ALIGN_TOP
			pY :+ GetHeight(pText) *scale_y
		EndIf
		' draw text char by char
		Local char:Byte
		For Local i:Int = 0 Until pText.length
			char = pText[i]
			' draw only valid chars
			If char <= 255 then
				DrawImage(image, pX, pY, char)
				' move drawing position
				pX :+ (widths[char] -offset_x +spacing) *scale_x
			EndIf
		Next
	End Method
	
	' return width of given text
	Method GetWidth:Float(pText:String)
		Local width:Float
		' sum up widths char by char
		Local char:Byte
		For Local i:Int = 0 Until pText.length
			char = pText[i]
			If char <= 255 then
				width :+ (widths[char] -offset_x +spacing)
			EndIf
		Next
		' subtract spacing once, for last char of text
		width :- spacing
		Return width
	End Method
	
	' return height of given text
	' function only exists for consistency
	Method GetHeight:Float(pText:String)
		Return fontheight
	End Method
End Type

' format pTime into string of format MM:SS.hh or SS.hh
Function FormatTime:String(pTime:Int)
	Local txt:String
	Local minutes:Int, seconds:Int, hundredth:Int
	' calculate fractions of time
	minutes = pTime / (60 *1000)
	seconds = (pTime / 1000) Mod 60
	hundredth = (pTime / 10) Mod 100
	' build String
	' write minutes, if greater than zero
	If minutes then
		txt = minutes +":"
	EndIf
	' add seconds
	If seconds < 10 then txt :+ "0"
	txt :+ seconds
	txt :+ "."
	' add hundredth
	If hundredth < 10 then txt :+ "0"
	txt :+ hundredth
	Return txt
End Function

' set the origin for graphic output with FadeFunc
Function FadeVertically(pDelay:Float)
	SetOrigin(0, -FadeFunc(pDelay) * SCREEN_HEIGHT)
End Function

' fade Function
' used to calculate displacement of objects during intermediate state
' returns value >= 0
' pVal is used to delay the effect (ranging from 0 to 1)
Function FadeFunc:Float(pVal:Float)
	' delayed fade value
	Local f:Float = App.statefade_value *2 +pVal * STATEFADE_MAXVALUE -1
	' clip below 0
	If f < 0 then f = 0
	' square value and return
	Return f*f
End Function

' draw a button,
' returns true if hit
Function Button:Byte(pText:String, pX:Float, pY:Float)
	Local sx:Float = pX -BUTTON_WIDTH /2
	Local ex:Float = pX +BUTTON_WIDTH /2
	Local sy:Float = pY -BUTTON_HEIGHT /2
	Local ey:Float = pY +BUTTON_HEIGHT /2
	' update first
	Local hover:Byte = False
	' highlight if mouse is on button
	If mx >= sx And mx < ex And my >= sy And my < ey then
		hover = True
	EndIf
	' draw background
	SetCol(COLOR_BUTTON_STROKE)
	If hover then SetCol(COLOR_BUTTON_STROKE_HL)
	DrawRect(sx, sy, BUTTON_WIDTH, BUTTON_HEIGHT)
	
	SetCol(COLOR_BUTTON_FILL)
	If hover then SetCol(COLOR_BUTTON_FILL_HL)
	DrawRect(sx+2, sy+2, BUTTON_WIDTH-4, BUTTON_HEIGHT-4)
	
	' draw text
	SetCol(COLOR_BUTTON_TEXT)
	SetScale(0.8, 0.8)
	font.Draw(pText, pX, pY, ALIGN_CENTER, ALIGN_CENTER)
	SetScale(1,1)
	' return true if hit
	If hover And mhit then Return True
End Function

' set a color, given by 3-int-array [r,g,b]
Function SetCol(pColor:Int[])
	SetColor(pColor[0], pColor[1], pColor[2])
End Function

' set a color, interpolated between pCol1 (0) and pCol2 (1)
' pInterp - interpolation value 0 .. 1
Function SetColInterp(pCol1:Int[], pCol2:Int[], pInterp:Float)
	Local dcol:Int[3]
	dcol[0] = pCol2[0] -pCol1[0]
	dcol[1] = pCol2[1] -pCol1[1]
	dcol[2] = pCol2[2] -pCol1[2]
	Local r:Int = pCol1[0] +dcol[0] *pInterp
	Local g:Int = pCol1[1] +dcol[1] *pInterp
	Local b:Int = pCol1[2] +dcol[2] *pInterp
	SetColor(r, g, b)
End Function
